(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tnp-core/browser')) :
    typeof define === 'function' && define.amd ? define('ng2-logger', ['exports', 'tnp-core/browser'], factory) :
    (global = global || self, factory(global['ng2-logger'] = {}, global.browser));
}(this, (function (exports, browser) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var __createBinding = Object.create ? (function(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
    }) : (function(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    });

    function __exportStar(m, o) {
        for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p)) __createBinding(o, m, p);
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }

    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
            if (ar || !(i in from)) {
                if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                ar[i] = from[i];
            }
        }
        return to.concat(ar || from);
    }

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    var __setModuleDefault = Object.create ? (function(o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function(o, v) {
        o["default"] = v;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }

    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m") throw new TypeError("Private method is not writable");
        if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var _a;

    (function (Level) {
        Level[Level["DATA"] = 0] = "DATA";
        Level[Level["INFO"] = 1] = "INFO";
        Level[Level["WARN"] = 2] = "WARN";
        Level[Level["ERROR"] = 3] = "ERROR";
        Level[Level["__NOTHING"] = 4] = "__NOTHING";
    })(exports.Level || (exports.Level = {}));
    var LevelKey = (_a = {},
        _a[exports.Level.DATA] = 'log',
        _a[exports.Level.INFO] = 'info',
        _a[exports.Level.WARN] = 'warn',
        _a[exports.Level.ERROR] = 'error',
        _a[exports.Level.__NOTHING] = '',
        _a);
    var LevelOrder = [
        LevelKey[exports.Level.DATA],
        LevelKey[exports.Level.INFO],
        LevelKey[exports.Level.WARN],
        LevelKey[exports.Level.ERROR],
    ];

    var Display = /** @class */ (function () {
        function Display() {
        }
        Display.msg = function (message, params, moduleName, moduleColor, level, moduleWidth, isProductionMode) {
            if (isProductionMode) {
                return;
            }
            ;
            var color = 'gray';
            if (level === exports.Level.INFO) {
                color = 'deepskyblue';
            }
            if (level === exports.Level.ERROR) {
                color = 'red';
            }
            if (level === exports.Level.WARN) {
                color = 'orange';
            }
            if (moduleWidth) {
                var diff = moduleWidth - moduleName.length;
                if (diff > 0) {
                    for (var i = 0; i < diff; i++) {
                        moduleName += ' ';
                    }
                }
            }
            if (browser.Helpers.isBrowser) {
                var isEdgeOrIe8orAbove = (document['documentMode'] || /Edge/.test(navigator.userAgent));
                if (isEdgeOrIe8orAbove) {
                    if (typeof message === 'string') {
                        var a1 = '[[ ' + moduleName + ' ]] ' + message + ' ';
                        params.unshift(a1);
                    }
                    else {
                        var a1 = '[[ ' + moduleName + ']] ';
                        params.push(message);
                        params.unshift(a1);
                    }
                    if (level === exports.Level.INFO) {
                        console.info.apply(console, params);
                    }
                    else if (level === exports.Level.ERROR) {
                        console.error.apply(console, params);
                    }
                    else if (level === exports.Level.WARN) {
                        console.warn.apply(console, params);
                    }
                    else {
                        console.log.apply(console, params);
                    }
                }
                else {
                    if (typeof message === 'string') {
                        var a1 = '%c ' + moduleName + '  %c ' + message + ' ';
                        var a2 = 'background: ' + moduleColor + ';color:white; border: 1px solid ' + moduleColor + '; ';
                        var a3 = 'border: 1px solid ' + color + '; ';
                        params.unshift(a3);
                        params.unshift(a2);
                        params.unshift(a1);
                    }
                    else {
                        var a1 = '%c ' + moduleName + ' ';
                        var a2 = 'background: ' + moduleColor + ';color:white; border: 1px solid ' + color + '; ';
                        params.push(message);
                        params.unshift(a2);
                        params.unshift(a1);
                    }
                    console.log.apply(console, params);
                }
            }
            if (browser.Helpers.isNode) {
            }
        };
        return Display;
    }());

    var Logger = /** @class */ (function () {
        function Logger(name, color, developmentMode, allowed, isMuted, fixedWidth) {
            var _this = this;
            this.name = name;
            this.color = color;
            this.developmentMode = developmentMode;
            this.allowed = allowed;
            this.isMuted = isMuted;
            this.fixedWidth = fixedWidth;
            /** @deprecated Use data(...)
             * @see data
            */
            this.d = function (name) {
                var data = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    data[_i - 1] = arguments[_i];
                }
                return _this._data(name, data);
            };
            /** @deprecated Use error(...)
             * @see error
            */
            this.er = function (name) {
                var data = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    data[_i - 1] = arguments[_i];
                }
                return _this._error(name, data);
            };
            /** @deprecated Use info(...)
             * @see info
            */
            this.i = function (name) {
                var data = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    data[_i - 1] = arguments[_i];
                }
                return _this._info(name, data);
            };
            /** @deprecated Use warn(...)
             * @see warn
            */
            this.w = function (name) {
                var data = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    data[_i - 1] = arguments[_i];
                }
                return _this._warn(name, data);
            };
            /**
             * Logs message and data with the level=data
             * @param message The message
             * @param otherParams Additional parameters
             */
            this.data = function (message) {
                var otherParams = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    otherParams[_i - 1] = arguments[_i];
                }
                return _this._data(message, otherParams);
            };
            /**
             * Logs message and data with the level=error
             * @param message The message
             * @param otherParams Additional parameters
             */
            this.error = function (message) {
                var otherParams = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    otherParams[_i - 1] = arguments[_i];
                }
                return _this._error(message, otherParams);
            };
            /**
             * Logs message and data with the level=info
             * @param message The message
             * @param otherParams Additional parameters
             */
            this.info = function (message) {
                var otherParams = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    otherParams[_i - 1] = arguments[_i];
                }
                return _this._info(message, otherParams);
            };
            /**
             * Logs message and data with the level=warn
             * @param message The message
             * @param otherParams Additional parameters
             */
            this.warn = function (message) {
                var otherParams = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    otherParams[_i - 1] = arguments[_i];
                }
                return _this._warn(message, otherParams);
            };
        }
        Logger.prototype.setLevel = function (l) {
            this._level = l;
            return this;
        };
        Object.defineProperty(Logger.prototype, "isProductionMode", {
            get: function () {
                return !this.developmentMode;
            },
            enumerable: false,
            configurable: true
        });
        Logger.prototype.setProductionMode = function (productionMode) {
            this.developmentMode = !productionMode;
            return this;
        };
        Logger.prototype.mute = function () {
            this.isMuted = true;
            return this;
        };
        Logger.prototype.onlyWhen = function (expression) {
            if (typeof expression === 'function') {
                this.isMuted = !expression();
            }
            else if (typeof expression === 'boolean') {
                this.isMuted = !expression;
            }
        };
        Logger.prototype._data = function (name) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            if (this.isMuted)
                return this;
            if (this.allowed.length >= 1 && browser.Helpers.contain(this.allowed, exports.Level.__NOTHING)
                && !browser.Helpers.contain(this.allowed, exports.Level.DATA))
                return this;
            if (this.allowed.length === 0 || browser.Helpers.contain(this.allowed, exports.Level.DATA)) {
                Display.msg.apply(void 0, __spreadArray(__spreadArray([
                    name
                ], __read(data)), [
                    this.name,
                    this.color,
                    exports.Level.DATA,
                    this.fixedWidth,
                    this.isProductionMode,
                ]));
            }
            return this;
        };
        Logger.prototype._error = function (name) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            if (this.isMuted)
                return this;
            if (this.allowed.length >= 1 && browser.Helpers.contain(this.allowed, exports.Level.__NOTHING)
                && !browser.Helpers.contain(this.allowed, exports.Level.ERROR))
                return this;
            if (this.allowed.length === 0 || browser.Helpers.contain(this.allowed, exports.Level.ERROR)) {
                Display.msg.apply(void 0, __spreadArray(__spreadArray([
                    name
                ], __read(data)), [
                    this.name,
                    this.color,
                    exports.Level.ERROR,
                    this.fixedWidth,
                    this.isProductionMode,
                ]));
            }
            return this;
        };
        Logger.prototype._info = function (name) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            if (this.isMuted)
                return this;
            if (this.allowed.length >= 1 && browser.Helpers.contain(this.allowed, exports.Level.__NOTHING)
                && !browser.Helpers.contain(this.allowed, exports.Level.INFO))
                return this;
            if (this.allowed.length === 0 || browser.Helpers.contain(this.allowed, exports.Level.INFO)) {
                Display.msg.apply(void 0, __spreadArray(__spreadArray([
                    name
                ], __read(data)), [
                    this.name,
                    this.color,
                    exports.Level.INFO,
                    this.fixedWidth,
                    this.isProductionMode,
                ]));
            }
            return this;
        };
        Logger.prototype._warn = function (name) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            if (this.isMuted)
                return this;
            if (this.allowed.length >= 1 && browser.Helpers.contain(this.allowed, exports.Level.__NOTHING)
                && !browser.Helpers.contain(this.allowed, exports.Level.WARN))
                return this;
            if (this.allowed.length === 0 || browser.Helpers.contain(this.allowed, exports.Level.WARN)) {
                Display.msg.apply(void 0, __spreadArray(__spreadArray([
                    name
                ], __read(data)), [
                    this.name,
                    this.color,
                    exports.Level.WARN,
                    this.fixedWidth,
                    this.isProductionMode,
                ]));
            }
            return this;
        };
        return Logger;
    }());

    var Log = /** @class */ (function () {
        //#region singleton
        function Log() {
            this._logOnly = false;
            this._logModules = false;
            this.isDevelopmentMode = true;
            this.modeIsSet = false;
            this.fixedWidth = 0;
            this.instances = {};
            this.levels = [];
            this.modules = [];
        }
        Object.defineProperty(Log, "instance", {
            // @ts-ignore
            get: function () {
                if (!Log['_instance']) {
                    Log['_instance'] = new Log();
                }
                return Log['_instance'];
            },
            enumerable: false,
            configurable: true
        });
        Log.create = function (name) {
            var _a;
            var level = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                level[_i - 1] = arguments[_i];
            }
            return (_a = Log.instance).create.apply(_a, __spreadArray([name], __read(level)));
        };
        Log.disableLogs = function (level) {
            var _this = this;
            if (level === void 0) { level = exports.Level.__NOTHING; }
            LevelOrder.reverse().find(function (a) {
                if (!_this.consolelogfn[a]) {
                    _this.consolelogfn[a] = console[a];
                }
                console[a] = function () { };
                if (a === LevelKey[level]) {
                    return true;
                }
                return false;
            });
        };
        Log.enableLogs = function () {
            var _this = this;
            LevelOrder.forEach(function (a) {
                console[a] = _this.consolelogfn[a];
            });
        };
        //#region public api
        Log.prototype.setProductionMode = function () {
            var _this = this;
            if (this.modeIsSet) {
                this.modeIsSet = false;
                throw '[ng2-logger] Production mode is already set';
            }
            else {
                this.modeIsSet = true;
                setTimeout(function () {
                    if (_this.modeIsSet && console !== void 0 && console.clear !== void 0) {
                        console.clear();
                        console.log = function () { };
                        console.error = function () { };
                        console.warn = function () { };
                        console.info = function () { };
                    }
                });
                this.isDevelopmentMode = false;
            }
        };
        Log.prototype.onlyModules = function () {
            var modules = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                modules[_i] = arguments[_i];
            }
            if (this._logModules) {
                throw '[ng2-logger] You should use funcion onlyModules only once';
            }
            if (!this._logModules) {
                this._logModules = true;
            }
            if (modules.length === 0)
                return;
            this.modules = modules;
            // console.log('only log this', Log.modules)
            this.muteAllOtherModules();
        };
        Log.prototype.onlyLevel = function () {
            var level = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                level[_i] = arguments[_i];
            }
            if (this._logOnly) {
                throw '[ng2-logger] You should use funcion onlyLevel only once';
            }
            if (!this._logOnly) {
                this._logOnly = true;
            }
            this.levels = Array.isArray(level) ? level : [level];
            for (var logName in this.instances) {
                if (this.instances.hasOwnProperty(logName)) {
                    var element = this.instances[logName];
                    element['allowed'] = this.levels;
                }
            }
        };
        //#endregion
        Log.prototype.create = function (name) {
            var level = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                level[_i - 1] = arguments[_i];
            }
            var i;
            if (Array.isArray(this.levels) && this.levels.length > 0) {
                level = this.levels;
            }
            if (this.instances[name] === void 0) {
                i = new (Log.Logger)(name, getRandomColor(), this.isDevelopmentMode, level, this.isMutedModule(name), this.levels.length > 0 ? this.fixedWidth : void 0);
                this.instances[name] = i;
            }
            else {
                i = this.instances[name];
            }
            return i;
        };
        Log.prototype.isMutedModule = function (moduleName) {
            if (this.modules.length == 0)
                return false;
            if (!browser.Helpers.contain(this.modules, moduleName))
                return true;
            return false;
        };
        Log.prototype.muteAllOtherModules = function () {
            for (var moduleName in this.instances) {
                if (!browser.Helpers.contain(this.modules, moduleName))
                    this.instances[moduleName].mute();
            }
        };
        //#endregion
        Log.Logger = Logger;
        Log.consolelogfn = {};
        return Log;
    }());
    function getRandomColor() {
        var letters = '012345'.split('');
        var color = '#';
        color += letters[Math.round(Math.random() * 5)];
        letters = '0123456789ABCDEF'.split('');
        for (var i = 0; i < 5; i++) {
            color += letters[Math.round(Math.random() * 15)];
        }
        if (color === void 0) {
            return getRandomColor();
        }
        ;
        return color;
    }

    exports.LevelKey = LevelKey;
    exports.LevelOrder = LevelOrder;
    exports.Log = Log;
    exports.Logger = Logger;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng2-logger.umd.js.map
